(define (domain coins)
  (:requirements :conditional-effects :equality :typing)
  (:types elevator floor pos coin)
  (:predicates (dec_f ?f ?g - floor)
               (dec_p ?p ?q - pos)
               (in ?e - elevator ?f - floor)
               (at ?f - floor ?p - pos)
               (shaft ?e - elevator ?p - pos)
               (inside ?e - elevator)
               (coin-at ?c - coin ?f - floor ?p - pos)
               (have ?c - coin)
  )
  (:action go-up
    :parameters (?e - elevator ?f ?nf - floor)
    :precondition (dec_f ?nf ?f)
    :effect (when (in ?e ?f) (and (in ?e ?nf) (not (in ?e ?f))))
  )
  (:action go-down
    :parameters (?e - elevator ?f ?nf - floor)
    :precondition (dec_f ?f ?nf)
    :effect (when (in ?e ?f) (and (in ?e ?nf) (not (in ?e ?f))))
  )
  (:action step-in
    :parameters (?e - elevator ?f - floor ?p - pos)
    :precondition (and (at ?f ?p) (shaft ?e ?p))
    :effect (when (in ?e ?f) (and (inside ?e) (not (at ?f ?p))))
  )
  (:action step-out
    :parameters (?e - elevator ?f - floor ?p - pos)
    :precondition (and (inside ?e) (shaft ?e ?p))
    :effect (when (in ?e ?f) (and (at ?f ?p) (not (inside ?e))))
  )
  (:action move-left
    :parameters (?f - floor ?p ?np - pos)
    :precondition (and (at ?f ?p) (dec_p ?p ?np))
    :effect (and (not (at ?f ?p)) (at ?f ?np))
  )
  (:action move-right
    :parameters (?f - floor ?p ?np - pos)
    :precondition (and (at ?f ?p) (dec_p ?np ?p))
    :effect (and (not (at ?f ?p)) (at ?f ?np))
  )
  (:action collect
    :parameters (?c - coin ?f - floor ?p - pos)
    :precondition (at ?f ?p)
    :effect (when (coin-at ?c ?f ?p) (and (have ?c) (not (coin-at ?c ?f ?p))))
  )
)
(define (problem coins_2_8_2_472)
  (:domain coins)
  (:objects e0 e1 - elevator f0 f1 - floor p0 p1 p2 p3 p4 p5 p6 p7 - pos c0 c1 c2 c3 c4 c5 - coin)
  (:init (and (dec_f f1 f0) (dec_p p1 p0) (dec_p p2 p1) (dec_p p3 p2) (dec_p p4 p3) (dec_p p5 p4) (dec_p p6 p5) (dec_p p7 p6) (shaft e0 p0) (oneof (in e0 f0) (in e0 f1)) (shaft e1 p3) (oneof (in e1 f0) (in e1 f1)) (oneof (coin-at c0 f0 p0) (coin-at c0 f0 p1) (coin-at c0 f0 p2) (coin-at c0 f0 p3) (coin-at c0 f0 p4) (coin-at c0 f0 p5) (coin-at c0 f0 p6) (coin-at c0 f0 p7)) (oneof (coin-at c1 f0 p0) (coin-at c1 f0 p1) (coin-at c1 f0 p2) (coin-at c1 f0 p3) (coin-at c1 f0 p4) (coin-at c1 f0 p5) (coin-at c1 f0 p6) (coin-at c1 f0 p7)) (oneof (coin-at c2 f0 p0) (coin-at c2 f0 p1) (coin-at c2 f0 p2) (coin-at c2 f0 p3) (coin-at c2 f0 p4) (coin-at c2 f0 p5) (coin-at c2 f0 p6) (coin-at c2 f0 p7)) (oneof (coin-at c3 f0 p0) (coin-at c3 f0 p1) (coin-at c3 f0 p2) (coin-at c3 f0 p3) (coin-at c3 f0 p4) (coin-at c3 f0 p5) (coin-at c3 f0 p6) (coin-at c3 f0 p7)) (oneof (coin-at c4 f1 p0) (coin-at c4 f1 p1) (coin-at c4 f1 p2) (coin-at c4 f1 p3) (coin-at c4 f1 p4) (coin-at c4 f1 p5) (coin-at c4 f1 p6) (coin-at c4 f1 p7)) (oneof (coin-at c5 f0 p0) (coin-at c5 f0 p1) (coin-at c5 f0 p2) (coin-at c5 f0 p3) (coin-at c5 f0 p4) (coin-at c5 f0 p5) (coin-at c5 f0 p6) (coin-at c5 f0 p7)) (at f0 p0)))
  (:goal (and (have c0) (have c1) (have c2) (have c3) (have c4) (have c5)))
)
