#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv)
{


  FILE * fp = stdout;
  int num_of_rooms = 4;
  int num_of_objects = 4;
  int i,j;
  int seed;
  char fname[100];
  char * err[1];
  

  if ((argc <= 2) || (argc >4)) {
    fprintf(stderr,"Usage: %s #of_rooms #of_objects \n",argv[0]);
    exit(1);
  }
  num_of_rooms = strtol(argv[1],err, 10);

  if ((strcmp(err[0], "") != 0) || (num_of_rooms < 1)) {
    fprintf(stderr,"Usage: %s #of_rooms #of_objects\n",argv[0]);
    exit(1);
  }

  num_of_objects = strtol(argv[2],err, 10);
  if ((strcmp(err[0], "") != 0) || (num_of_rooms < 1)) {
    fprintf(stderr,"Usage: %s #of_rooms #of_objects\n",argv[0]);
    exit(1);
  }
  
  sprintf(fname,"clea_log_%s_%s.smv",argv[1],argv[2]);
  if ((fp = fopen(fname,"w")) == NULL) {
    perror(fname);
    exit(1);
  }
  
  fprintf(fp, "-- Cleaner Rooms Objects \n");
  fprintf(fp, "-- Called as: %s %s %s\n",argv[0], argv[1], argv[2]);
  fprintf(fp, "-- cleaner_%s_%s\n\nMODULE main\n\n",argv[1], argv[2]);
  fprintf(fp, "IVAR\n  act : {\n\twait,\n\tfwd,\n\tback");
  for (i=0;i<num_of_objects;i++) 
    fprintf(fp, ",\n\tclean_%d",i);
  fprintf(fp, "\n      };\n\n");
  fprintf(fp, "VAR\n");
  fprintf(fp, "\tpos : 0..%d ; ", num_of_rooms - 1);

  for (i=0;i< num_of_objects;i++) 
       for (j=0;j<num_of_rooms;j++) 
           fprintf(fp, "\n\tcleaned_%d_%d : boolean;",i,j);

  fprintf(fp, "\n\n");

  fprintf(fp, "ASSIGN next(pos) := \n case ");
  fprintf(fp, "\n  act = fwd & pos < %d : pos + 1;", num_of_rooms - 1);
  fprintf(fp, "\n  act = back & pos > 0 : pos - 1;");
  fprintf(fp, "\n  1 : pos; \n esac; \n\n");

 
  for (i=0;i<num_of_objects;i++) 
    for (j=0;j<num_of_rooms;j++) 
      {
	fprintf(fp, "ASSIGN next(cleaned_%d_%d) := \n case \n",i,j);
	fprintf(fp, "  act = clean_%d & pos = %d : 1;\n",i,j);  
	fprintf(fp, "  1 : cleaned_%d_%d;\n",i, j);  
	fprintf(fp, " esac;\n\n");
      }

  fprintf(fp, "\nINIT pos=0\n");

  fprintf(fp, "\nNULL_OBS_STRONG_GOAL");
  for (i=0;i<num_of_objects;i++) 
       for (j=0;j<num_of_rooms;j++) 
           fprintf(fp, "\n\tcleaned_%d_%d & ",i,j);
           fprintf(fp, "\n\t TRUE ");

  fclose(fp);
}

