#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv)
{


  FILE * fp = stdout;
  int size = 4;
  int i,j;
  int seed;
  char fname[100];
  

  if (argc != 2) {
    fprintf(stderr,"Usage: %s #combinations\n",argv[0]);
    exit(1);
  }
  size = atoi(argv[1]);
	printf("number of combinations: %d\n",size);
  sprintf(fname,"safe_log_%d.smv",size);
  if ((fp = fopen(fname,"w")) == NULL) {
    perror(fname);
    exit(1);
  }
  
  fprintf(fp, "-- Safe \n");
  fprintf(fp, "MODULE main\n");
  fprintf(fp, "IVAR\n  act : {\n\twait");
  for (i=0;i<size;i++) 
    fprintf(fp, ",\n\ttry_%d",i);
  fprintf(fp, "\n      };\n\n");
  fprintf(fp, "VAR\n");
  fprintf(fp, "\tright_combination : 0..%d ; ", size-1);
  fprintf(fp, "\tsafe_open: boolean;");

  fprintf(fp, "\n\n");

  fprintf(fp, "ASSIGN next(safe_open) := \n case ");
  for (i = 0; i < size; i++) {
  fprintf(fp, "\n  act = try_%d & right_combination=%d : 1;", i,i);
}
  fprintf(fp, "\n  1 : safe_open; \n esac; \n\n");

  fprintf(fp, "ASSIGN next(right_combination) := \n case ");
  fprintf(fp,  "\n 1 : right_combination; \n esac; \n\n");

  fprintf(fp, "\nINIT TRUE\n");

  fprintf(fp, "\nNULL_OBS_STRONG_GOAL \n \t safe_open & TRUE ");

  fclose(fp);
}

